unit TestApp1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Grids, Mask;

type
  TForm1 = class(TForm)
    PageList: TPageControl;
    Setup: TTabSheet;
    ExitBtn: TButton;
    SetPort: TButton;
    Label1: TLabel;
    SPort: TEdit;
    Memo1: TMemo;
    ComboBox1: TComboBox;
    POpen: TButton;
    PClose: TButton;
    Label4: TLabel;
    Timer1: TTimer;
    ClrLog: TButton;
    SendFile: TButton;
    StopSending: TButton;
    LabelFN: TLabel;
    Image1: TImage;
    TstFile: TButton;
    DebugCB: TCheckBox;
    procedure ExitBtnClick(Sender: TObject);
    procedure SetPortClick(Sender: TObject);
    procedure Startup(Sender: TObject);
    procedure POpenClick(Sender: TObject);
    procedure PCloseClick(Sender: TObject);
    procedure CheckSerial(Sender: TObject);
    procedure ClrLogClick(Sender: TObject);
    procedure SendFileClick(Sender: TObject);
    procedure StopSendingClick(Sender: TObject);
    procedure TstFileClick(Sender: TObject);
  private
    { Private declarations }
    myfile : TextFile;
    sendingdata,nextline,waitok,waitdelay : boolean;
    delaytime : integer;
    RecBuffer: string;
    fileName : string;
    LineNo : integer;
    openDialog : TOpenDialog;
    function ComVisualWrite(const sData: string): boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses selectport;

{$R *.DFM}

type TColourmap = array[0..7] of TColor;
var FPortHandle: DWORD; {handle from OpenComm }
const colours : TColourmap = (clWhite, clBlack, clBlue, clNavy, clGray, clGray, clPurple, clPurple);

{
Close the COM port
}
function ClosePort() : boolean;
begin
        Result:=false;
	if FPortHandle <> INVALID_HANDLE_VALUE then Result:=CloseHandle(FPortHandle);
	FPortHandle := INVALID_HANDLE_VALUE;
end;


function OpenPort(sCom : string; sSpeed : integer): boolean;
var
	dcbPort: TDCB; {device control block }
	boolAbort: boolean;
	sErrMsg: string;
        LastError: DWORD;

begin

	{ init }
	boolAbort := True;

	{ close port if open already }
	if FPortHandle <> INVALID_HANDLE_VALUE then
  	ClosePort();

	{ try to open the port }
	repeat
	begin
		FPortHandle := CreateFile(PChar('\\.\'+sCom), GENERIC_READ or GENERIC_WRITE, 0, nil,
					OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, longint(0));

		if (FPortHandle = INVALID_HANDLE_VALUE) then
		begin
                        LastError:=GetLastError();
			if MessageDlg('Chyba otevrn ' + sCom + ': ' + sErrMsg + IntToStr(LastError),
				mtWarning, [mbAbort, mbRetry], 0) = idAbort then
				boolAbort := True
			else
				boolAbort := False;
			end;
		end;
	until (FPortHandle <> INVALID_HANDLE_VALUE) or (boolAbort = True);

	{ set the baud rate and other parameters }
	if (FPortHandle <> INVALID_HANDLE_VALUE) then
	begin
		if GetCommState(FPortHandle, dcbPort) then
		begin
			{ fill in the fields of the structure }
			dcbPort.BaudRate := sSpeed;
			dcbPort.ByteSize := 8;
			dcbPort.Parity := NOPARITY;
			dcbPort.StopBits := ONESTOPBIT;
			//dcbPort.Flags := 1;  {dcb_Binary}
			//dcbPort.Flags := $3015; {dcb_Binary or dcb_OutxCtsFlow or dcb_RtsFlow}
			dcbPort.Flags := DTR_CONTROL_ENABLE shl 4; {dcb_Binary or dcb_OutxCtsFlow or dcb_RtsFlow}
			{ flag bit fields:
			dcb_Binary, dcb_Parity, dcb_OutxCtsFlow, dcb_fOutxDsrFlow,
			dcb_fOutX, dcb_fInX, dcb_DtrFlow, dcb_RtsFlow
			}
{			case FHandshake of
      	hsNone:
        	dcbPort.Flags := 1;
        hsHardware:
        	dcbPort.Flags := $3005;
}        {
        hsXonXoff:
        	dcbPort.Flags := ???
        }
{      end;}
{  DWORD DCBlength;
  DWORD BaudRate;
  DWORD fBinary  :1;
  DWORD fParity  :1;
  DWORD fOutxCtsFlow  :1;
  DWORD fOutxDsrFlow  :1;
  DWORD fDtrControl  :2;
  DWORD fDsrSensitivity  :1;
  DWORD fTXContinueOnXoff  :1;
  DWORD fOutX  :1;
  DWORD fInX  :1;
  DWORD fErrorChar  :1;
  DWORD fNull  :1;
  DWORD fRtsControl  :2;
  DWORD fAbortOnError  :1;
  DWORD fDummy2  :17;
  WORD  wReserved;
  WORD  XonLim;
  WORD  XoffLim;
  BYTE  ByteSize;
  BYTE  Parity;
  BYTE  StopBits;
  char  XonChar;
  char  XoffChar;
  char  ErrorChar;
  char  EofChar;
  char  EvtChar;
  WORD  wReserved1;
}

			SetCommState(FPortHandle, dcbPort);
		end;
	end;

	{ return True if handle is valid }
	Result := (FPortHandle <> INVALID_HANDLE_VALUE);
end;

{ Write a string out the COM port, return true if all chars written }
function ComWrite(const sData: string): boolean;
var
	dwCharsWritten: DWord;
begin
	dwCharsWritten := 0;
	Result := False; { default to error return }

	if FPortHandle <> INVALID_HANDLE_VALUE then
	begin
		WriteFile(FPortHandle, PChar(sData)^, Length(sData), dwCharsWritten, nil);
		if dwCharsWritten = DWORD(Length(sData)) then
      Result := True;
	end;
end;

{
Reads a string from the port.
}
function ComRead: string;
const
	BUF_LEN = 1024;
var
	cbCharsAvailable, cbCharsRead: DWORD;
       	dwErrorCode: DWord;
	statPort: TCOMSTAT;

begin
	{ init }
	Result := '';

	ClearCommError(FPortHandle, dwErrorCode, @statPort);
	cbCharsAvailable := statPort.cbInQue;


      if cbCharsAvailable > 0 then
      begin
        SetLength(Result, cbCharsAvailable); { allocate space - was + 1}
        ReadFile(FPortHandle, PChar(Result)^, cbCharsAvailable, cbCharsRead, nil);
        SetLength(Result, cbCharsRead); { adjust length }
      end;
end;

function ComReadTo(nochar, timeout : integer): string;
const
	BUF_LEN = 1024;
var
	cbCharsAvailable, cbCharsRead: DWORD;
	boolExit: boolean;
	sBuffer: string;
	lEndTime: DWORD;
        FTimedOut: boolean;
       	dwErrorCode: DWord;
	statPort: TCOMSTAT;
begin
	{ init }
	Result := '';
	boolExit := False;
	lEndTime := GetTickCount + (timeout*1000); { get end time 100ms}
	FTimedOut := False;

	{ loop until timeout or terminator recieved }
	repeat
       	        ClearCommError(FPortHandle, dwErrorCode, @statPort);
                cbCharsAvailable := statPort.cbInQue;

		if cbCharsAvailable > 0 then
			begin
                        	lEndTime := GetTickCount + (timeout*1000); { get end time 100ms}
			// allocate space in buffer
				if cbCharsAvailable >= DWORD(Length(sBuffer)) then
					SetLength(sBuffer, cbCharsAvailable);
				ReadFile(FPortHandle, PChar(sBuffer)^, cbCharsAvailable, cbCharsRead, nil);
                                Result := Result + Copy(sBuffer, 0, cbCharsRead); // append chars to end of buffer
			end else sleep(10);

		if Length(Result) >= nochar then
		  	boolExit := True // we are done reading the response
		else
                    begin
                        { check for timeout }
                        if (GetTickCount > lEndTime) then
                        FTimedOut := True;

                    end;
	until (FTimedOut) or (boolExit);

end;


procedure TForm1.ExitBtnClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.SetPortClick(Sender: TObject);
begin
  Form3.selport:=SPort.Text;
    if Form3.showmodal = 1 then
   begin
    Memo1.Lines.Add('Selected port '+Form3.selport);
    SPort.Text:=Form3.selport;
    ComboBox1.ItemIndex:=3;
    ComboBox1.Enabled:=True;
    POpen.Enabled:=True;
    PClose.Enabled:=False;
    SendFile.Enabled:=False;
   end else
   begin
    Memo1.Lines.Add('Un Selected port');
    SPort.Text:='none';
    ComboBox1.Enabled:=False;
    POpen.Enabled:=False;
    PClose.Enabled:=False;
    SendFile.Enabled:=False;
   end

end;

procedure TForm1.Startup(Sender: TObject);
begin
    ComboBox1.ItemIndex :=0;
    RecBuffer:='';
end;

procedure TForm1.POpenClick(Sender: TObject);
begin
  Memo1.Lines.Add('Opening port '+Form3.selport + ' ' + ComboBox1.Items[ComboBox1.ItemIndex]);
  if OpenPort(SPort.Text, StrToInt(ComboBox1.Items[ComboBox1.ItemIndex]))
   then
    begin
     Memo1.Lines.Add('Opened '+Form3.selport + ' ' + ComboBox1.Items[ComboBox1.ItemIndex]);
     ComboBox1.Enabled:=False;
     POpen.Enabled:=False;
     PClose.Enabled:=True;
     SendFile.Enabled:=True;
     SendFile.Enabled:=True;
     SetPort.Enabled:=False;
     ComboBox1.Enabled:=False;
     //Timer1.Enabled:=True;
    end
   else
    begin
     Memo1.Lines.Add('Error open '+Form3.selport + ' ' + ComboBox1.Items[ComboBox1.ItemIndex]);
    end;
end;

procedure TForm1.PCloseClick(Sender: TObject);
begin
  Memo1.Lines.Add('Closing port '+Form3.selport + ' ' + ComboBox1.Items[ComboBox1.ItemIndex]);
  if ClosePort()
   then
    begin
     Memo1.Lines.Add('Closed '+Form3.selport + ' ' + ComboBox1.Items[ComboBox1.ItemIndex]);
     POpen.Enabled:=True;
     PClose.Enabled:=False;
     SendFile.Enabled:=False;
     SetPort.Enabled:=True;
     ComboBox1.Enabled:=True;
     Timer1.Enabled:=False;
    end
   else
    begin
     Memo1.Lines.Add('Error close ');
    end;
end;

procedure TForm1.CheckSerial(Sender: TObject);
var
    radek, radek2, radek3 : string;
    copyit : boolean;
    i : integer;
    dwErrorCode: DWord;
    statPort: TCOMSTAT;
    Data: string;
begin
   //Memo1.Valid:=False;
   if sendingdata then        // Did the user select a file?
   begin
     if waitdelay then
       begin
         if delaytime=0 then
           begin
             waitok:=False; nextline:=True; waitdelay:=False;
           end
         else
           begin
             dec(delaytime);
             //Memo1.Lines.Add('Wait: '+radek3+' '+inttostr(delaytime));
           end;
       end;
     if nextline then
      begin
       if eof(myfile) then
        begin
         sendingdata:=false;
         CloseFile(myfile);
         StopSending.Enabled:=False;
         SendFile.Enabled:=True;
        end
       else
        begin
         Readln(myfile, radek);
         if DebugCB.Checked then Memo1.Lines.Add('F: '+radek);
         radek2:='';copyit:=True;
         for i:=1 to length(radek) do
          if copyit then
           begin
            if radek[i]='(' then copyit:=false else radek2:=radek2+radek[i];
           end
          else
            if radek[i]=')' then copyit:=true;
         if radek2='M01 ' then
           begin
             Timer1.Enabled:=False;
             MessageDlg(radek, mtInformation, [mbOK], 0);
             Timer1.Enabled:=True;
           end;
         if (Pos('G4 P',radek2)=1) then
           begin
             radek3:='';
             for i:=4 to length(radek2) do if (radek2[i]>='0') and (radek2[i]<='9') then radek3:=radek3+radek2[i];
             delaytime:=strtoint(radek3) div Timer1.Interval;
             if DebugCB.Checked then Memo1.Lines.Add('Wait: '+radek3+' '+inttostr(delaytime));
             waitok:=False; nextline:=False; waitdelay:=True;
             radek2:='';
           end;
         if radek2<>'' then
            begin
               ComVisualWrite(radek2+#13+#10);
               waitok:=True; nextline:=False;
               Memo1.Lines.Add('Rp:');
               LineNo:=Memo1.Lines.Count-1;
            end;
        end;
      end;

     if waitok then
      begin
       ClearCommError(FPortHandle, dwErrorCode, @statPort);
       if (statPort.cbInQue > 0) then
         begin
          Data:=ComRead;
          RecBuffer:= RecBuffer+Data;
          for i:=Memo1.Lines.Count-2 downto LineNo do
             Memo1.Lines.Delete(i);
          Memo1.Lines.Add('Rp: '+StringReplace(StringReplace(RecBuffer,#10,'\r',[rfReplaceAll, rfIgnoreCase]),#13,'\n',[rfReplaceAll, rfIgnoreCase]));
         end;
       //if Pos(#13,RecBuffer)>0 then Memo1.Lines.Add('R: '+StringReplace(StringReplace(RecBuffer,#10,'*',[rfReplaceAll, rfIgnoreCase]),#13,'%',[rfReplaceAll, rfIgnoreCase]));
       if (Pos(#13#10,RecBuffer)>0) and (Pos(#13#10#10'ok '#13#10#10'ok '#13#10,RecBuffer)>0) then
        begin
         //Memo1.Lines.Delete(Memo1.Lines.Count-2);
          for i:=Memo1.Lines.Count-2 downto LineNo do
             Memo1.Lines.Delete(i);
         Memo1.Lines.Add('R: '+StringReplace(StringReplace(RecBuffer,#10,'\r',[rfReplaceAll, rfIgnoreCase]),#13,'\n',[rfReplaceAll, rfIgnoreCase]));
         //Memo1.Lines[LineNo]:='R: '+StringReplace(StringReplace(RecBuffer,#10,'\r',[rfReplaceAll, rfIgnoreCase]),#13,'\n',[rfReplaceAll, rfIgnoreCase]);
         RecBuffer:='';
         waitok:=False; nextline:=True;
        end;
      end;
   end;
end;

function TForm1.ComVisualWrite(const sData: string): boolean;
begin
  //Memo1.Lines.Add('W: '+sData);
  if DebugCB.Checked then Memo1.Lines.Add('W: '+StringReplace(StringReplace(sData,#10,'\r',[rfReplaceAll, rfIgnoreCase]),#13,'\n',[rfReplaceAll, rfIgnoreCase]));

  Result:=ComWrite(sData+#13);
end;

procedure TForm1.ClrLogClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;


procedure TForm1.SendFileClick(Sender: TObject);
begin
   openDialog := TOpenDialog.Create(self);
   openDialog.Options := [ofFileMustExist,ofHideReadOnly];
   openDialog.Filter := 'G-Code (*.gcode)|*.gcode|All files (*.*)|*.*';
   if openDialog.Execute then        // Did the user select a file?
   begin
     //Timer1.Enabled:=False;
     fileName := openDialog.FileName;
     //fileName := 'D:\Local_Documents\hardware\eggbot\eggbot\heart.gcode';
     Memo1.Lines.Add('Open file: '+fileName);
     LabelFN.Caption:=fileName;
     AssignFile(myfile, fileName);
     Reset(myfile);
     sendingdata:=True;
     nextline:=True;
     waitok:=false;
     Timer1.Enabled:=True;
     SendFile.Enabled:=False;
     StopSending.Enabled:=True;
   end;
end;

procedure TForm1.StopSendingClick(Sender: TObject);
begin
  sendingdata:=false;
  CloseFile(myfile);
  StopSending.Enabled:=False;
  Timer1.Enabled:=False;
end;

procedure TForm1.TstFileClick(Sender: TObject);
var radek,radek2 : string;
    i,j,x,y : integer;
    myfile2 : TextFile;

begin
   openDialog := TOpenDialog.Create(self);
   openDialog.Options := [ofFileMustExist,ofHideReadOnly];
   openDialog.Filter := 'G-Code (*.gcode)|*.gcode|All files (*.*)|*.*';
   if openDialog.Execute then        // Did the user select a file?
   begin
     //Timer1.Enabled:=False;
     fileName := openDialog.FileName;
     //fileName := 'D:\Local_Documents\hardware\eggbot\eggbot\heart.gcode';
     Memo1.Lines.Add('Open file: '+fileName);
     LabelFN.Caption:=fileName;
     AssignFile(myfile2, fileName);
     Reset(myfile2);
     Image1.Canvas.Pen.Color := clWhite;
     Image1.Canvas.Pen.Style := psSolid;
     Image1.Canvas.Rectangle(0,0,450,128);
     Image1.Canvas.MoveTo(225,64);
     Image1.Canvas.Pen.Color := clBlack;
     j:=0;
     while not eof(myfile2) do
      begin
       Readln(myfile2, radek);
       inc(j);
       if DebugCB.Checked then Memo1.Lines.Add('F'+inttostr(j)+': '+radek);
       if (Pos('M300 S50',radek)=1) then Image1.Canvas.Pen.Color := clGray;
       if (Pos('M300 S30',radek)=1) then Image1.Canvas.Pen.Color := clBlue;
       if (Pos('G1 X',radek)=1) then
        begin
         i:=Pos('X',radek)+1;
         if radek[i]='-' then begin radek2:='-'; inc(i); end else radek2:='';
         repeat
          radek2:=radek2+radek[i];
          inc(i);
         until (i>length(radek)) or (radek[i]>'9') or (radek[i]<'0');
         x:=strtoint(radek2);
         i:=Pos('Y',radek)+1;
         if radek[i]='-' then begin radek2:='-'; inc(i); end else radek2:='';
         repeat
          radek2:=radek2+radek[i];
          inc(i);
         until (i>length(radek)) or (radek[i]>'9') or (radek[i]<'0');
         y:=strtoint(radek2);
         Image1.Canvas.LineTo((x div 2)+225,64 - (y));
        end;
      end;
     CloseFile(myfile2);
   end;
end;

end.
