unit selectport;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm3 = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1MouseMove (Sender: TObject; Shift: TShiftState; X, Y: Integer) ;

  private
    { Private declarations }
    lastsel: integer;
  public
    { Public declarations }
    selport: string;
  end;

var
  Form3: TForm3;

//function CheckOS(var VersionInfo : TOSVersionInfo) : Integer;
//procedure GetPortList(Strings : TStrings);



implementation

{$BOOLEVAL OFF}
uses Registry; //,SysUtils;

{$R *.DFM}

function CheckOS(var VersionInfo : TOSVersionInfo) : Integer;
begin
{
dwOSVersionInfoSize: DWORD;
dwMajorVersion: DWORD;
dwMinorVersion: DWORD;
dwBuildNumber: DWORD;
dwPlatformId: DWORD;
szCSDVersion: array[0..127] of AnsiChar; // Maintenance string for PSS usage
}
 VersionInfo.dwOSVersionInfoSize := SizeOf(VersionInfo);
 if GetVersionEx(VersionInfo) then
  CheckOS := VersionInfo.dwPlatformId
 else
  CheckOS := -1;
end;

procedure GetPortList(Strings : TStrings);
var Reg : TRegistry;

 procedure ScanRegHardware;
 var
  i : integer;
  PortName : string;
  LName : TStringList;
 begin
  if Reg.OpenKeyReadOnly('\hardware\devicemap\serialcomm') then
   begin
    LName := TStringList.Create;
    Reg.GetValueNames(LName);
    for i := 0 to LName.Count - 1 do
     begin
      if Reg.GetDataType(LName.Strings[i]) = rdString then
       begin
        PortName := Reg.ReadString(LName.Strings[i])  + ''^I'' + LName.Strings[i];
        if Strings.IndexOf(PortName) < 0 then
         Strings.Add(PortName);
       end
     end;
    LName.Free;
   end
 end;

 procedure ScanRegEnum(Key : String);
 // This Subprocedure recurses thru all keys below key
 var
  LKey : TStringList;
  LName : TStringList;
  i : Integer;
  Driver, PortName : String;
  PortSubClass : Byte;
 begin
  if not Reg.OpenKeyReadOnly(Key) then // Danke Andreas Schmidt!
   Exit;
  LName := TStringList.Create;
  Reg.GetValueNames(LName);
  i := LName.IndexOf('class');
  if i >= 0 then
   begin
    if (Reg.GetDataType('class') = rdString) and
       ((LowerCase(Reg.ReadString('class')) = 'ports') or //normal Serialports like COMx
        (LowerCase(Reg.ReadString('class')) = 'modem')) and //some abnormal onboard Modems
       (Reg.GetDataType('driver') = rdString) and
       (Reg.GetDataType('portname') = rdString) then
     begin
      Driver := Reg.ReadString('driver');
      PortName := Reg.ReadString('portname');
      if Reg.OpenKeyReadOnly('\System\CurrentControlSet\Services\Class\'+ Driver) and
         (Reg.ReadBinaryData('PortSubClass',PortSubClass,1) = 1) and
          ((PortSubClass = 1) or //Ports
           (PortSubClass = 2)) and //Modems
          (Strings.IndexOf(PortName) < 0) then
       Strings.Add(PortName);
     end
   end;
  LName.Free;
  Reg.OpenKeyReadOnly(Key);
  if Reg.HasSubKeys then
   begin
    LKey := TStringList.Create;
    Reg.GetKeyNames(LKey);
    for i := 0 to LKey.Count - 1 do
     begin
      ScanRegEnum(Key + '\' + LKey[i]);
     end;
    LKey.Free;
   end;
 end;

var
VersionInfo : TOSVersionInfo;
begin
if CheckOS(VersionInfo) > 0 then
 if VersionInfo.dwMajorVersion >= 4 then
  begin
   Reg := TRegistry.Create;
   Reg.RootKey := HKEY_LOCAL_MACHINE;
    if VersionInfo.dwMajorVersion > 4 then
     ScanRegHardware //Win 2k, XP
    else if VersionInfo.dwMinorVersion > 0 then
     ScanRegEnum('\enum') //Win9x, mE
    else
     ScanRegHardware; //WinNT
   Reg.Free;
  end;
end;


procedure TForm3.BitBtn1Click(Sender: TObject);
var i:integer;
    infotxt : TStringList;
    txt : string;
    ver : integer;
    working : boolean;
    addt : string;
begin
 lastsel:=ListBox1.ItemIndex;
 if ListBox1.ItemIndex>=0 then
  begin
   selport:=ListBox1.Items.Strings[ListBox1.ItemIndex];
   if Pos(^I,selport)>0 then selport:=Copy(selport,1,Pos(^I,selport)-1);
   ModalResult:=1;
  end
  else
   ModalResult:=-1;
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
begin
 ModalResult:=-1;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
 selport:='';
 lastsel:=0;
end;

procedure TForm3.FormShow(Sender: TObject);
var porty : TStringList;
begin
 porty:=TStringList.Create;
 porty.Clear;
 GetPortList(porty);
 Listbox1.Items:=porty;
 ListBox1.ItemIndex:=lastsel;
end;


procedure TForm3.ListBox1MouseMove (Sender: TObject; Shift: TShiftState; X, Y: Integer) ;
var lstIndex : Integer ;
begin
  with ListBox1 do
  begin
   lstIndex:=SendMessage(Handle, LB_ITEMFROMPOINT, 0, MakeLParam(x,y)) ;
   if (lstIndex >= 0) and (lstIndex <= Items.Count) then
     Hint := Copy(Items[lstIndex],Pos(^I,Items[lstIndex])+1,length(Items[lstIndex]))
   else
     Hint := ''
  end;
end;



end.
